﻿/*Copyright 2024 Wojciech Krzysztof Fiałkiewicz

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

using System;
using System.Collections.Generic;

namespace Functions
{
    public class MathFun
    {
        public static bool IsValid(double val)
        {
            if (Double.IsInfinity(val) || Double.IsNaN(val))
            {
                return false;
            }
            return true;
        }

        public bool CanCalculate
        {
            get
            {
                return true;
            }
        }

        private Function1DT m_Fun1DT;
        
        public bool SetFunctionBody1DT(Function1DT fun)
        {
            m_Fun1DT = fun;
            return true;
        }

        public bool CalculateFunction1DT(ref List<double> prevs, double x, double t, out double y, out bool connect)
        {
            y = m_Fun1DT.Calculate(ref prevs, x, t, out connect);

            if (IsValid(y))
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        private Function2DT m_Fun2DT;
        
        public bool SetFunctionBody2DT(Function2DT fun)
        {
            m_Fun2DT = fun;
            return true;
        }

        public bool CalculateFunction2DT(ref List<double> prevs, ref List<FunctionsAdapter.FUN> funcs, double x, double z, double t, out double y)
        {
            y = m_Fun2DT.Calculate(ref prevs, ref funcs, x, z, t);
            
            if (IsValid(y))
            {
                return true;
            }
            else
            {
                return false;
            }
        }

        private Function3DT m_Fun3DT;        

        public bool SetFunctionBody3DT(Function3DT fun)
        {
            m_Fun3DT = fun;
            return true;
        }

        public bool CalculateFunction3DT(ref List<double> prevs, ref List<FunctionsAdapter.FUN> funcs, double x, double z, double y, double t, out double q)
        {
            q = m_Fun3DT.Calculate(ref prevs, ref funcs, x, z, y, t);

            if (IsValid(q))
            {
                return true;
            }
            else
            {
                return false;
            }
        }
    }
}
