﻿/*Copyright 2024 Wojciech Krzysztof Fiałkiewicz

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"),
to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense,
and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.*/

namespace PointsManager._2D
{
    public class InnerDataPoint3D
    {
        public static double ScreenDistance = 5.0;

        public double X_Min { get; set; }
        public double X_Max { get; set; }
        public double Y_Min { get; set; }
        public double Y_Max { get; set; }
        public double Z_Min { get; set; }
        public double Z_Max { get; set; }

        public double Screen_Width { get; set; }
        public double Screen_Height { get; set; }

        public double x_scale;
        public double y_scale;
        public double x_scaled_beg;
        public double y_scaled_beg;
               
        public void CalculateScales()
        {
            x_scale = Screen_Width / (X_Max - X_Min);
            y_scale = Screen_Height / (Y_Max - Y_Min);
            x_scaled_beg = (-X_Min) * x_scale;
            y_scaled_beg = (-Y_Min) * y_scale;
        }

        public const int ANGLE_OF_PI = 180;
    }
}
